module Main where

import Mandel
import PortablePixmap
import System.IO
import System.Environment
import System.Time
import Text.Printf

main = 	do
  (minx_: miny_: maxx_: maxy_: screenX_ : screenY_ : limit_ : _) <- getArgs -- set window size and number of iterations
  t1 <- getClockTime
  let [minx,miny,maxx,maxy] = map read [minx_,miny_,maxx_,maxy_]
      [screenX,screenY]     = map read [screenX_,screenY_]
      limit                 = read limit_

  hSetBinaryMode stdout True
  putStr (show (mandelset minx miny maxx maxy screenX screenY limit))
  t2 <- getClockTime
  writeFile "time.txt" (printf "time taken: %.2fs" $ secDiff t1 t2) 

readNum::(Num a, Read a) => String -> [String] -> (a->[String]->IO ()) -> IO ()
readNum prompt inputLines succ
   = hPutStr stderr prompt >>
     case inputLines of
       (x:xs) -> case (reads x) of
		   [(y,"")] -> succ y xs
		   _	    -> hPutStr stderr "Error - retype the number\n" >>
			       readNum prompt xs succ
       _ 	-> hPutStr stderr "Early EOF"


secDiff::ClockTime -> ClockTime -> Float
secDiff (TOD secs1 psecs1) (TOD secs2 psecs2) = fromInteger (psecs2 - psecs1) / 1e12 + fromInteger (secs2 - secs1)



