module Main(main) where

import System.Environment (getArgs)
import Control.Parallel
import System.Time
import Text.Printf

main = do [arg1,arg2] <- getArgs
	  
          let
            n = read arg1 :: Int  -- input for parfib
            t = read arg2 :: Int  -- threshold
          t1 <- getClockTime
          let res = parfib n t
          putStrLn ("parfib " ++ show n ++ " = " ++ show res)
          t2 <- getClockTime
          putStrLn $ printf "time taken: %.2fs" $ secDiff t1 t2

-- parallel version of the code with thresholding
parfib :: Int -> Int -> Int
parfib n t | n <= t = nfib n
           | otherwise = n1 `par` (n2 `pseq` n1 + n2 + 1)
	                 where n1 = parfib (n-1) t
			       n2 = parfib (n-2) t

-- sequential version of the code
nfib :: Int -> Int
nfib 0 = 1
nfib 1 = 1
nfib x = nfib (x-2) + nfib (x-1) + 1

-- func to calc time taken between t0 and t1 in sec
secDiff::ClockTime -> ClockTime -> Float
secDiff (TOD secs1 psecs1) (TOD secs2 psecs2) = fromInteger (psecs2 - psecs1) / 1e12 + fromInteger (secs2 - secs1)
