import System (getArgs) 
import Control.Monad
import Control.Parallel
import System.Time
import Text.Printf


main = do
   args <- getArgs
   unless (length args == 2) $ 
     error (unlines ["Usage: parfib <m> <n>","  generate <n> parallel task computing parfib <m> each"])
   putStrLn ("n = "++ args!!0)
   t1 <- getClockTime
   let m = (read (args!!0))::Integer -- input for parfib
       n = (read (args!!1))::Integer -- number of parfib computations
       res = spawnN m n
   putStrLn ("Result: "++(show res))
   t2 <- getClockTime
   putStrLn $ printf "time taken: %.2fs" $ secDiff t1 t2

-- spawn n instances of parfib m 

spawnN :: Integer -> Integer -> Integer
spawnN m 0 = 0
spawnN m n = this `par` (rest `pseq` (rest+this))
  where this = parfib m 23 
        rest = spawnN m (n-1)

-- parallel implementation of fibonacci
parfib :: Integer -> Integer -> Integer
parfib n t | n <= t = nfib n
           | otherwise = n1 `par` (n2 `pseq` n1 + n2 + 1)
  where n1 = parfib (n-1) t
        n2 = parfib (n-2) t

nfib :: Integer -> Integer
nfib 0 = 1
nfib 1 = 1
nfib n = nfib (n-1) + nfib (n-2)

-- func to calc time taken between t0 and t1 in sec
secDiff::ClockTime -> ClockTime -> Float
secDiff (TOD secs1 psecs1) (TOD secs2 psecs2) = fromInteger (psecs2 - psecs1) / 1e12 + fromInteger (secs2 - secs1)
